;compile by TASM /m2

;(c) 1999 by N.Yu.Zolotykh
;32-bit modification & improvements (c) 2000 by Max A. Alekseyev
;University of Nizhni Novgorod, Russia

.386p
.model flat
locals @@

.code

public _do_big_int_to_bdn
public _do_bdn_to_big_int
public _do_add
public _do_sub
public _do_optimize
public _do_mult
public _do_mult_by_digit
public _do_divide_by_digit
public _do_divide

_do_big_int_to_bdn proc C ;(digit * a, digit * b, digit n, bdn_radix)
ARG a, b, n, r : dword

        xor eax,eax
        cmp eax, n
        je on_return


        pushad
        mov esi, a
        mov edi, b

        xor ecx, ecx          ;count digits in the result

        mov ebx, n
        lea ebx, [ebx*4-4]

next_digit:

	push ebx
	xor edx, edx

div_loop:
        mov eax, [esi+ebx]
        div r
        mov [esi+ebx], eax
        sub ebx, 4
        jnc div_loop

        pop ebx

        inc ecx              ;count digits in the result
        mov [edi], edx       ;residue: the new digit in the result
        add edi, 4
        xor eax, eax
        cmp [esi+ebx], eax
        jne next_digit

        sub ebx,4
        jnc next_digit

        mov [esp+1Ch], ecx           ;return the number of digits in the result
        popad

on_return:

	ret
_do_big_int_to_bdn endp

_do_bdn_to_big_int proc C ;(digit * a, digit * b, digit n, radix)
ARG a, b, n, r : dword
LOCAL m, carry : dword

        pushad
        mov esi, a            ;first, optimize

        std

        mov ecx, n            ;count of digits n
        lea ebx,[ecx*4-4]     ;4*(n-1)
        lea edi,[esi+ebx]
        xor eax, eax
        repe scasd            ;find non-zero
        mov m, eax            ;m==0
        je @@end        ;if non found  return: all digits are zeros
        inc ecx               ;the number of non-zero digits
        add edi,4

        mov esi, edi
        mov edi, b

        lodsd

        mov [edi], eax
        mov m, 1
        dec ecx
        jecxz @@end

@@loop_:

        push ecx
        mov ecx, m
        xor ebx, ebx
        mov carry, ebx

mul_loop:

        mov eax, [edi+ebx]
        mul r
        add eax, carry
        adc edx, 0
        mov carry, edx
        mov [edi+ebx], eax
        add ebx, 4
        loop mul_loop

        cmp carry, 0
        je h1
        mov eax, carry
        mov [edi+ebx], eax
        inc m

h1:
        mov ecx, m
        dec ecx
        xor ebx, ebx
        lodsd
        add [edi], eax
        mov eax,1
        jecxz @@label_1

add_loop:

	jnc h2
        add ebx,4
        add [edi+ebx], eax
        loop add_loop                 ; jmp ????

@@label_1:

        jnc h2
        add ebx,4
        mov [edi+ebx], eax
        inc m

h2:
        pop ecx
        loop  @@loop_

@@end:  popad
	mov eax, m
        cld             ;Don't forget to restore D flag!!!

	ret
_do_bdn_to_big_int endp


_do_add	 proc C ;(digit * p1, digit * p2, digit m, digit n)
ARG p1, p2, m, n : dword

          pushad
          mov ecx, n
          mov edx, m
          sub edx, ecx

          mov esi, p1
          mov edi, p2

          xor ebx, ebx              ; ebx = 0}

          clc                       ; clear 䫠 ७}

@@loop1:
          mov eax, [edi+ebx*4]
          adc [esi+ebx*4], eax
          inc ebx           
          loop @@loop1

          mov ecx, edx              ; ecx = m-n
          jecxz @@lastfig           ;if m==n  done

          mov edx, 0                ;preserve C flag

@@loop2:
          adc [esi+ebx*4], edx
          inc ebx
          loop @@loop2

@@lastfig:
          jnc @@end
          mov edx, 1
          mov [esi+ebx*4], edx

@@end:    add ebx, edx
          mov [esp+1Ch], ebx              ; Return the number of "figures" /4
          popad

	  ret
_do_add	endp


_do_sub proc C ;(digit * p1, digit * p2, digit m, digit n)
ARG p1, p2, m, n : dword

        pushad
        mov ecx, n
        mov edx, m
        sub edx, ecx

        mov esi, p1
        mov edi, p2

        xor ebx, ebx              ; ebx = 0

        clc                       ; clear cf
@@loop1:
	mov eax, [edi+ebx]
        sbb [esi+ebx], eax
        lea ebx, [ebx+4]          ; invalid: add ebx, 4
        loop @@loop1

        mov ecx, edx              ; ecx = m-n
        mov eax, 0                ; invalid: xor edx, edx
        jecxz @@lastfig     ; if m==n  done
@@loop2:
        sbb [esi+ebx], eax
        lea ebx, [ebx+4]          ; invalid: add ebx, 4
        loop @@loop2
@@lastfig:
        jae @@end          ; if  뫮   return eax == 0
        mov eax, 1               ; else return 1

@@end:  mov [esp+1Ch], eax
        popad
	ret
_do_sub endp


_do_optimize proc C ;(digit * a, digit n)
ARG a, n : dword

        pushad
        mov ecx, n
        xor eax, eax
        jecxz @@end
        lea edi, [ecx*4-4]
        add edi, a
        std
        repe scasd             ; find non-zero}
        cld
        je @@end         ; if non found  return}
        mov eax, ecx
        inc eax
@@end:  mov [esp+1Ch], eax
        popad
	ret
_do_optimize endp

_do_mult proc C ;(digit *u, digit *v, digit *w, digit m, digit n)
ARG u, v, w, m, n : dword
LOCAL vj : dword

        pushad
        cld             ;forward scanning
        mov edi, w
        mov ecx, m
        xor eax, eax
        rep stosd

        mov ecx, n        
loopj:  
        mov esi, v
        lodsd
        mov vj, eax
        mov v, esi

        push ecx         ;save j
        mov ecx, m
        mov esi, u
        mov edi, w

        xor ebx, ebx
loopi:
        lodsd
        mul vj                  ;x:y == edx:ax = u_i * v_j
        add eax, ebx
        adc edx, 0
        add eax, [edi]      
        adc edx, 0               ;+ ७
        stosd        
        mov ebx, edx              ;७
        loop loopi

        mov [edi], ebx
        pop ecx
        add w, 4
        loop loopj

        mov [esp+1Ch], ebx              ;return major digit
        popad
	ret
_do_mult endp

_do_mult_by_digit proc C ;(digit * a, digit * p, digit n, digit d)
ARG a, p, n, d : dword

        pushad
        mov esi, a
        mov edi, p

        mov ecx, n
        xor ebx,ebx       
        cld
@@loop_:

        lodsd
        mul d
        add eax, ebx
        adc edx, 0
        mov ebx, edx
        stosd
        loop @@loop_

        mov [edi], ebx
        mov [esp+1Ch], ebx          
        popad
	ret
_do_mult_by_digit endp

_do_divide_by_digit proc C ;(digit * a, digit * p, digit n, digit d)
ARG a, p, n, d : dword

        pushad
        mov esi, a
        mov edi, p
        mov ecx, d
        mov ebx, n
        lea ebx, [ebx*4-4]
        xor edx, edx
@@loop_:

        mov eax, [esi+ebx]
        div ecx                  ;eax = edx:eax div ecx; edx = edx:eax mod ecx
        mov [edi+ebx], eax
        sub ebx, 4
        jnc @@loop_

@@label_1:
	mov [esp+1Ch], edx              ;return residue
        popad
	ret
_do_divide_by_digit endp

_do_divide proc C ;(digit * u, digit * v, digit * q, digit m, digit n)
ARG u, v, q, m, n : dword
LOCAL two_n, two_m, v_n_minus_one, v_n_minus_two, d, q_hat, r_hat : dword

      pushad
      mov edi, u
      mov esi, v

      mov ebx, n
      shl ebx, 2
      mov two_n, ebx
      mov eax, [esi+ebx-4]
      mov v_n_minus_one, eax

      mov eax, m
      shl eax, 2
      mov two_m, eax

;/**********************************************************************/

     ;d1: find d && normilize

       mov edx, 1
       xor eax, eax                 ;b
       mov ecx, v_n_minus_one
       inc ecx
       jz j1
       div ecx
       mov d, eax
       jmp j2

j1:

	mov d, edx

j2:

     ;multiply v by d

       xor ecx, ecx                  ;carry
       mov ebx, ecx                  ;count

@@loop_d1_1:

       mov eax, [esi+ebx]
       mul d
       add eax, ecx
       adc edx, 0
       mov ecx, edx
       mov [esi+ebx], eax
       add ebx,4
       cmp ebx, two_n
       jb @@loop_d1_1


     ;multiply u by d

       xor ecx, ecx                      ;carry
       mov ebx, ecx                      ;count

@@loop_d1_2:

       mov eax, [edi+ebx]
       mul d
       add eax, ecx
       adc edx, 0
       mov ecx, edx
       mov [edi+ebx], eax
       add ebx,4
       cmp ebx, two_m
       jb @@loop_d1_2
       mov [edi+ebx], ecx

;**********************************************************************

     ;d2: loop on j==bx

     ;initialize v_n_minus_one, v_n_minus_two

       mov ebx, n
       mov eax, [esi+ebx*4-4]
       mov v_n_minus_one, eax
       mov eax, [esi+ebx*4-8]
       mov v_n_minus_two, eax

       mov ebx, m
       sub ebx, n
       shl ebx, 2                  ;bx == 4*(m-n)
       add edi, two_m

;**********************************************************************

     ;d3: calculate q_hat

d3:

       mov edx, [edi]            ;u[j+n]
       mov eax, [edi-4]          ;u[j+n-1]
       cmp edx, v_n_minus_one
       jae @@label_1                    ;u[j+n] >== v[n-1]
       div v_n_minus_one
       mov r_hat, edx
       mov q_hat, eax
       jmp label_2

@@label_1:

       mov eax, -1            ; q_hat = ffff
       mov edx, [edi-4]        ; u[j+n-1]
       jmp label_4

label_3:

       mov eax, q_hat
       dec eax
       mov edx, r_hat

label_4:

       mov q_hat, eax
       add edx, v_n_minus_one
       jc d4
       mov r_hat, edx

label_2:

       mov eax, q_hat
       mul v_n_minus_two
       cmp edx, r_hat
       jb d4                           ; <
       ja label_3                      ; >
       cmp eax, [edi-8]
       ja label_3                      ; >

;************************************************************************

     ;d4: multiply && subtract

d4:

       push ebx
       sub edi, two_n               ;u[m]

       xor ecx, ecx                  ;carry
       mov ebx, ecx                  ;count

@@loop_d4:

       mov eax, [esi+ebx]          ;v[bx]
       mul q_hat
       add eax, ecx
       adc edx, 0
       sub [edi+ebx], eax          ;u[bx]
       adc edx, 0
       mov ecx, edx                  ;new carry
       add ebx,4
       cmp ebx, two_n
       jb @@loop_d4
       sub [edi+ebx], ecx

d5:

	jnc d7

;*************************************************************************

d6: ;q_hat correction

       dec q_hat
       mov ecx, n                   ;count
       xor ebx, ebx
       clc                         ;carry

@@loop_d6:

       mov eax, [esi+ebx]          ;v[bx]
       adc [edi+ebx], eax          ;u[bx]
       lea ebx,[ebx+4]
       loop  @@loop_d6
       xor eax, eax
       adc [edi+ebx], eax

;*************************************************************************

    ;d7: end loop on ebx

d7:

       add edi, two_n
       pop ebx

;record q[j]

       push edi
       mov edi, q
       mov eax, q_hat
       mov [edi+ebx], eax
       pop edi

;end loop on ebx

       sub edi,4
       sub ebx,4
       jnc d3

;*********************************************************************

d8:  ;denormalize

       mov edi, u
       mov ebx, n
       lea ebx, [ebx*4-4] 	;ebx=4*(n-1)
       xor edx, edx
       mov ecx, d

@@loop_d8:

       mov eax, [edi+ebx]
       div ecx
       mov [edi+ebx], eax
       sub ebx, 4
       jnc @@loop_d8

;***********************************************************************

    ;optimize u

       std
       mov esi, u
       mov ecx, n
       lea ebx, [ecx*4-4]
       lea edi, [esi+ebx]
       xor eax, eax
       repe scasd     ;find non-zero
       je @@end        ;if non found  return
       lea eax, [ecx+1]       ;return eax == the number of digits in u

@@end:

     mov [esp+1Ch],eax
     popad

     cld
     ret
_do_divide endp

end
